inline double doubleadd(double x1, double y1){

    if(x1==0.0)
    {
    	return y1;
    }

    else if(y1==0.0)
    {
    	return x1;
    }
    else//none of 0
    {

	int test,acc,sign_result;
    long long temp,checkx,checky;
    unsigned long long mask_result=0x0000000000000000;
    unsigned long long exp_result;



    unsigned long long realx;
    unsigned long long * maskx=(unsigned long long *) &x1;
    long long signx,expx;
    signx=(0x8000000000000000&*maskx)>>63;
    expx= (0x7FF0000000000000&*maskx)>>52;
    realx= 0x000FFFFFFFFFFFFF&*maskx;
    //checkx=realx+expx;
    realx|=0x0010000000000000;

    unsigned long long realy;
    unsigned long long * masky=(unsigned long long *) &y1;
    long long signy,expy;
    signy=(0x8000000000000000&*masky)>>63;
    expy= (0x7FF0000000000000&*masky)>>52;
    realy= 0x000FFFFFFFFFFFFF&*masky;
    //checky=realy+expy;
    realy|=0x0010000000000000;


    	if(signx==signy)
    	{
        	sign_result=signx;
        	if(expx>=expy)
        	{
            	temp=(realx)+(realy>>(expx-expy));
            	test=(0x20000000000000&temp)>>53;
            	if(test==1){
            		mask_result=(0x1FFFFFFFFFFFFF&temp)>>1;
                	exp_result=expx+1;
            	}
            	else{
            		mask_result=(0x0FFFFFFFFFFFFF&temp);
                	exp_result=expx;
            	}
        	}

        	else//expx<expy
        	{
            	temp=(realy)+(realx>>(expy-expx));
            	test=(0x20000000000000&temp)>>53;
            	if(test==1){
            		mask_result=(0x1FFFFFFFFFFFFF&temp)>>1;
                	exp_result=expy+1;
            	}
            	else{
            		mask_result=(0x0FFFFFFFFFFFFF&temp);
                	exp_result=expy;
            	}
        	}
    	}
    	else//signx!=signy
    	{
        	if(expx>expy)
        	{

            	sign_result=signx;
            	temp=(realx)-(realy>>(expx-expy));
            	if(temp==0)	return 0;
            	acc=0;test=(0x10000000000000&temp)>>52;
            	while(test!=1){
            		temp<<=1;
            		test=(0x10000000000000&temp)>>52;
            		acc++;
            	}
            	mask_result=(0x0FFFFFFFFFFFFF&temp);
                exp_result=expx-acc;
            	/*test=(0x10000000000000&temp)>>52;
            	if(test==0){
                	mask_result=(0x07FFFFFFFFFFFF&temp)<<1;
                    exp_result=expx-1;
            	}
            	else{
                	mask_result=(0x0FFFFFFFFFFFFF&temp);
                    exp_result=expx;
            	}*/

        	}
        	else if(expx<expy)
        	{
            	sign_result=signy;
            	temp=(realy)-(realx>>(expy-expx));
            	if(temp==0)	return 0;
            	acc=0;test=(0x10000000000000&temp)>>52;
            	while(test!=1){
            		temp<<=1;
            		test=(0x10000000000000&temp)>>52;
            		acc++;
            	}
            	mask_result=(0x0FFFFFFFFFFFFF&temp);
                exp_result=expy-acc;
        	}
        	else//expx=expy
        	{
        		if(realx>=realy){
                	sign_result=signx;
                	temp=(realx)-(realy);
                	if(temp==0)	return 0;
                	acc=0;test=(0x10000000000000&temp)>>52;
                	while(test!=1){
                		temp<<=1;
                		test=(0x10000000000000&temp)>>52;
                		acc++;
                	}
                	mask_result=(0x0FFFFFFFFFFFFF&temp);
                    exp_result=expx-acc;
        		}
        		else{
                	sign_result=signy;
                	temp=(realy)-(realx);
                	if(temp==0)	return 0;
                	acc=0;test=(0x10000000000000&temp)>>52;
                	while(test!=1){
                		temp<<=1;
                		test=(0x10000000000000&temp)>>52;
                		acc++;
                	}
                	mask_result=(0x0FFFFFFFFFFFFF&temp);
                    exp_result=expx-acc;
        		}
        	}
    	}
    	exp_result=(exp_result<<52);
    	mask_result|=exp_result;
    	if(sign_result==1)
    		mask_result|=0x8000000000000000;
    	else
  	     mask_result&=0x7FFFFFFFFFFFFFFF;
    	double *result=(double *)&mask_result;
    	double outcome=*result;
    	return outcome;
  }

}

/*printf("x1 is %f, dewindow is %f,y1 is %f, buf is %f\n",
		x1,dewindow[k],y1,((*buf) [ch] [( (k + ( ((i+1)>>1) <<6) ) + bufOffset[ch]) & 0x3ff]));*/


inline double doublemul(double x1, double y1){


    if(x1==0.0||y1==0.0){
    	double outcome=0;
    	return outcome;
    }
    else
    {
	int test,sign_result;
    long long temp,checkx,checky;
    unsigned long long mask_result=0x0000000000000000;
    unsigned long long exp_result;



    unsigned long long realx;
    unsigned long long * maskx=(unsigned long long *) &x1;
    long signx,expx;
    signx=(0x8000000000000000&*maskx)>>63;
    expx= (0x7FF0000000000000&*maskx)>>52;
    realx= 0x000FFFFFFFFFFFFF&*maskx;
    //checkx=realx+expx;
    realx|=0x0010000000000000;

    unsigned long long realy;
    unsigned long long * masky=(unsigned long long *) &y1;
    long signy,expy;
    signy=(0x8000000000000000&*masky)>>63;
    expy= (0x7FF0000000000000&*masky)>>52;
    realy= 0x000FFFFFFFFFFFFF&*masky;
    //checky=realy+expy;
    realy|=0x0010000000000000;

    temp=(realx>>27)*(realy>>27);
    test=(0x8000000000000&temp)>>51;
    if(test==1){
        mask_result=(0x7FFFFFFFFFFFF&temp)<<1;
        exp_result=expx+expy-1022;//1074;
    }
    else{
        mask_result=(0x3FFFFFFFFFFFF&temp)<<2;
        exp_result=expx+expy-1023;//1075;
    }

    exp_result=(exp_result<<52);
    mask_result|=exp_result;
    sign_result=signx+signy;
    if(sign_result==1)
        mask_result|=0x8000000000000000;
    else
        mask_result&=0x7FFFFFFFFFFFFFFF;

    //double* result=&mask_result;
    double *result=(double *)&mask_result;
    double outcome=*result;
    return outcome;
  }

}
