//NOTE:The codes between "-----AIFF_HEADER_TMP-----" is for generating .aiff file.
//If you just wanna generate pure PCM file without aiff header, then just disable those codes;
//Notice that there are several places with "-----AIFF_HEADER_TMP-----".

//What's more, I have changed the variable "temp" to "frameNum" since it is not temp any more
//And you should remove the huffman data print out codes since they are slowing down the execution;


#define TESTFRAME 1000

#include "home/user4/fall09/ml3088/laizheng/playeri/MP3_all/SEG7_LUT_8/inc/basic_io.h"
#include "basic.h"
#include "header_reader.h"
#include "get_scalefactor.h"
#include "requantize.h"
#include "huffman_decode.h"
#include "print_function.h"
#include "reorder.h"
#include "joint_stereo.h"
#include "antialias.h"
#include "hybrid.h"
#include "subbandsynthesis.h"
#include "math.h"
#include <alt_types.h>



void main()
{
    unsigned char *address_of_first_frame;
    unsigned char *index;
    unsigned int frameNum=0;//use to count the frame
    unsigned char valid[2]={1,1};
    unsigned long int sycnword_count=0;
    unsigned char ii=0; //This variable is used to denote the number of frame that are being analyzed.
    int clip=0;

    printf("OK start.\n");//test;
    find_the_first_frame(&address_of_first_frame,&sycnword_count);
    frame_stat=0;//test;
    sycnword_count=sycnword_count-2;
    block_type_0_count=0;//test;
    //printf("address_of_first_frame is %d\n",address_of_first_frame - data_header);//test;
    index=address_of_first_frame;
    si[0].main_data_end=0;si[1].main_data_end=0;

 
    initialize_huffman();

    for(frameNum=1;frameNum<TESTFRAME+1;frameNum++)
    {
        printf("%d",frameNum);
        ii++;
        if(ii>1) ii=0;
        
        header_reader(&index,&sycnword_count,&header_info[ii],&si[ii],&si[bit_add(ii)],&main_data_beg_bs[ii],&valid[ii]);
        /*if((valid[1]==1)&&(valid[0]==1))
        {
        //printf("I have found the %dst frame starting at this address:%d\n",frameNum,index-header_info[ii].frame_length-data_header);
        }
        else
        {
            //printf("bad frame detected.I quit.\n");exit(0);

        }*/

        int ch,gr;
        for(gr=0;gr< grNum;gr++)
        {
        for(ch=0;ch< stereo;ch++)
        {
            get_scale_factors(&si[ii],&scalefac,gr,ch,main_data_beg_bs[ii]);
            //printf("start of huffman\n");
            huffman_decode(is, &si[ii], ch, gr,&header_info[ii],&main_data_beg_bs[ii]);

            main_data_beg_bs[ii].byte_idx_ptr+=(si[ii].ch[ch].gr[gr].part2_3_length/8);
            if(main_data_beg_bs[ii].bit_idx>=(si[ii].ch[ch].gr[gr].part2_3_length%8))
            {
                main_data_beg_bs[ii].bit_idx-=(si[ii].ch[ch].gr[gr].part2_3_length%8);
            }
            else
            {
                main_data_beg_bs[ii].byte_idx_ptr++;
                main_data_beg_bs[ii].bit_idx=main_data_beg_bs[ii].bit_idx+8-si[ii].ch[ch].gr[gr].part2_3_length%8;
            }
            //printf("start of requantize\n");
            
            requantize(&header_info[ii],&scalefac,&si[ii],is,ro[ch],gr,ch);
            //printf("end of requantize\n");
            //print_scalefac(frameNum, gr, ch, si[ii]);//test;
            //print_requantize(frameNum,gr,ch,ro[ch]);//test;

        }
        //printf("start of stereo\n");
        join_stereo(ro,lr,&scalefac,&(si[ii].ch[ch].gr[gr]),&header_info[ii]);

        for(ch=0;ch< stereo;ch++)
        {
            reorder (lr[ch],re,&(si[ii].ch[ch].gr[gr]),&header_info[ii]);
            antialias(re, hybridIn, &(si[ii].ch[ch].gr[gr]), &header_info[ii]);

            unsigned char sb=0;
            unsigned char ss=0;

            for (sb=0; sb<SBLIMIT; sb++)
            {
                hybrid(hybridIn[sb], hybridOut[sb], sb, ch, &(si[ii].ch[ch].gr[gr]),&header_info[ii]);
            }
//printf("done.\n");
            for (ss=0;ss<18;ss++)
                for (sb=0; sb<SBLIMIT; sb++)
                      if ((ss%2) && (sb%2))
                             hybridOut[sb][ss] = -hybridOut[sb][ss];

            //print_hybrid_output(frameNum,gr,ch,hybridOut);//test;
            //printf("synthesis start\n");
            for (ss=0;ss<18;ss++)
            {
                for (sb=0; sb<SBLIMIT; sb++)
                    polyPhaseIn[sb] = hybridOut[sb][ss];
                SubBandSynthesis (polyPhaseIn, ch,&(pcm_sample[ch][ss][0]));
                unsigned int i;
                 for(i=0;i<SBLIMIT;)
            {
                if(!IORD_16DIRECT(0x00681104,0))
                {
                    usleep(8);
                    IOWR_16DIRECT(0x00681104,0,(unsigned short)((pcm_sample[ch][ss][i+1]<<8)|pcm_sample[ch][ss][i]));
                    i+=2;
                }
            }
            
            }
            //printf("synthesis done\n");
        }

        //print_pcm_sample(frameNum,gr,pcm_sample);//test;

        //file_output(pcm_sample,fp,&sample_frames);
        }
        
        
    }
printf("done\n");  



//----------------------test information print out---------------------------;
/*  printf("Frame_stat is %d\n",frame_stat);printf("bad_block_count is %d\n",bad_block_count);
    printf("big_value_0_count is %d\n",big_value_0_count);
    printf("big_value_1_count is %d\n",big_value_1_count);
    printf("block_type_0_count is %d\n",block_type_0_count);*/
    //printf("index taken by next circulation is %d\n",index);
    //printf("ptr in main_data_bs structure, bit_idx is %d, byte_idx(offset) is %d.\n", main_data_bs.bit_idx, (unsigned long int)(main_data_bs.byte_idx_ptr-data_header));printf("\n");}
    //byte_idx tells you the location of maindata in forms of  offset from the starting point of data_header
    /*printf("ht[33] info :---------------\n");
        {
            printf("table name is %s"   ,ht[33].tablename);
            printf("xlen is:%d   ",ht[33].xlen);
            printf("ylen is:%d   ",ht[33].ylen);
            printf("lintbis is:%d   ",ht[33].linbits);
            printf("treelen is:%d   ",ht[33].treelen);
            printf("the first  2 values are:0x%x 0x%x   ",ht[33].val[0][0],ht[33].val[0][1]);
            printf("the second 2 values are:0x%x 0x%x   ",ht[33].val[1][0],ht[33].val[1][1]);
            printf("the third  2 values are:0x%x 0x%x   \n",ht[33].val[2][0],ht[33].val[2][1]);

        }*/
}

